package com.android.launcher3

interface LauncherOverlayCallbacks {
    fun onScrollChanged(progress: Float)
}

interface LauncherOverlay {

    /**
     * Touch interaction leading to overscroll has begun
     */
    fun onScrollInteractionBegin()

    /**
     * Touch interaction related to overscroll has ended
     */
    fun onScrollInteractionEnd()

    /**
     * Scroll progress, between 0 and 100, when the user scrolls beyond the leftmost
     * screen (or in the case of RTL, the rightmost screen).
     */
    fun onScrollChange(progress: Float, rtl: Boolean)

    /**
     * Called when the launcher is ready to use the overlay
     * @param callbacks A set of callbacks provided by Launcher in relation to the overlay
     */
    fun setOverlayCallbacks(callbacks: LauncherOverlayCallbacks)
}