package com.teslacoilsw.kotlin

import android.os.SystemClock
import timber.log.Timber

class TicToc(val tag: String) {
    private var lastTime = SystemClock.uptimeMillis();

    fun tic() {
        lastTime = SystemClock.uptimeMillis();
    }

    fun tocv(msg: String) {
        Timber.tag(tag).v("$msg ${SystemClock.uptimeMillis() - lastTime}ms")
        tic()
    }

    fun tocd(msg: String) {
        Timber.tag(tag).d("$msg ${SystemClock.uptimeMillis() - lastTime}ms")
        tic()
    }

    inline fun <T> runv(msg: String, body: () -> T): T {
        tic()
        try {
            return body.invoke();
        } finally {
            tocv(msg);
        }
    }

    inline fun <T> rund(msg: String, body: () -> T): T {
        tic()
        try {
            return body.invoke();
        } finally {
            tocv(msg);
        }
    }
}