package com.teslacoilsw.kotlin

import android.os.Build
import android.os.SystemClock
import android.os.Trace
import com.teslacoilsw.shared.util.Log

inline fun trace(sectionName: String, body: () -> Unit) {
    if (Build.VERSION.SDK_INT < Build.VERSION_CODES.JELLY_BEAN_MR2) {
        body()
        return
    }
    Trace.beginSection(sectionName)
    try {
        body()
    } finally {
        Trace.endSection()
    }
}

inline fun <T> ticToc(sectionName: String, body: () -> T) = ticToc("TicToc", sectionName, body)
inline fun <T> ticToc(tag: String, sectionName: String, body: () -> T): T {
    val t = SystemClock.uptimeMillis()
    try {
        return body()
    } finally {
        Log.v(tag, "$sectionName  ${SystemClock.uptimeMillis() - t}ms")
    }
}