package com.teslacoilsw.kotlin

import android.graphics.Bitmap
import android.graphics.Canvas
import java.io.File
import java.io.FileOutputStream

inline fun Long.compare(that: Long): Int = if (this < that) -1 else if (this == that) 0 else 1

inline fun <T> tryCatch(defaultValue: T, body: () -> T) : T {
    return try {
        body()
    } catch (e: Exception) {
        defaultValue
    }
}

fun Bitmap.compressTo(path: String) {
    compress(Bitmap.CompressFormat.PNG, 100, FileOutputStream(File(path)))
}

fun Canvas.resetAfter(body: () -> Unit) {
    val save = save()
    try {
        body()
    } finally {
        restoreToCount(save)
    }
}