package com.teslacoilsw.launcher.dragndrop

import android.app.Activity
import android.content.pm.LauncherApps
import android.os.Build
import android.os.Bundle
import android.support.annotation.RequiresApi
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import android.widget.Toast
import com.android.launcher3.InstallShortcutReceiver
import com.android.launcher3.InstallShortcutReceiver.PendingInstallShortcutInfo
import com.android.launcher3.compat.PinItemRequestCompat
import com.android.launcher3.shortcuts.DeepShortcutInfoCompatV25
import com.teslacoilsw.launcher.R


@RequiresApi(Build.VERSION_CODES.O)
class AddItemActivity: Activity() {

    private val launcherApps by lazy(LazyThreadSafetyMode.NONE) { getSystemService(LauncherApps::class.java)!! }
    private lateinit var request: PinItemRequestCompat

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        val localRequest = PinItemRequestCompat.getPinItemRequest(intent)

        if (localRequest == null) {
            finish()
            return
        }
        request = localRequest

        setContentView(R.layout.add_item_confirmation_activity)
        val label: TextView = findViewById(R.id.label)
        val dimens: TextView = findViewById(R.id.dimens)
        val preview: ImageView = findViewById(R.id.preview)

        if (request.requestType == LauncherApps.PinItemRequest.REQUEST_TYPE_SHORTCUT) {
            val shortcutInfo = DeepShortcutInfoCompatV25(request.shortcutInfo)
            val icon = launcherApps.getShortcutIconDrawable(request.shortcutInfo, resources.displayMetrics.densityDpi)

            label.text = shortcutInfo.longLabelWithFallback
            dimens.text = "Shortcut"

            preview.setImageDrawable(icon)

//            findViewById<View>(R.id.preview_frame).setOnLongClickListener { v ->
//                val intent = Intent(Intent.ACTION_MAIN).addCategory(Intent.CATEGORY_HOME).setPackage(BuildConfig.APPLICATION_ID).setFlags(268435456)
//                startActivity(intent)
//
//                v.startDragAndDrop(ClipData(ClipDescription("Hello", arrayOf("com.android.launcher3.drag_and_drop/*")), ClipData.Item("")), object: View.DragShadowBuilder() {
//                    override fun onDrawShadow(canvas: Canvas?) {
//                        Timber.v("onDrawShadow")
//                        super.onDrawShadow(canvas)
//                    }
//
//                    override fun onProvideShadowMetrics(outShadowSize: Point?, outShadowTouchPoint: Point?) {
//                        Timber.v("onProvideShadowMetrics")
//                        super.onProvideShadowMetrics(outShadowSize, outShadowTouchPoint)
//                    }
//                }, null, 256)
//                true
//            }
        } else if (request.requestType == LauncherApps.PinItemRequest.REQUEST_TYPE_APPWIDGET) {

        } else {
            Toast.makeText(this, "Unable to handle request of unknown type ${request.requestType}", Toast.LENGTH_SHORT).show()
            finish()
            return
        }
    }

    fun onCancelClick(v: View) {
        finish()
    }

    /**
     * Called when place-automatically button is clicked.
     */
    fun onPlaceAutomaticallyClick(v: View) {
        if (request.requestType == PinItemRequestCompat.REQUEST_TYPE_SHORTCUT) {
//            InstallShortcutReceiver.queueShortcut(
//                    DeepShortcutInfoCompatV25(request.shortcutInfo), this)
            val shortcutInfo = DeepShortcutInfoCompatV25(request.shortcutInfo)
            val info = PendingInstallShortcutInfo(shortcutInfo, this)
            InstallShortcutReceiver.queuePendingShortcutInfo(this, info)
            request.accept()
            finish()

            Toast.makeText(this, getString(R.string.item_added), Toast.LENGTH_SHORT).show();
            return
        }

//        mPendingBindWidgetId = mAppWidgetHost.allocateAppWidgetId()
//        val success = mAppWidgetManager.bindAppWidgetIdIfAllowed(
//                mPendingBindWidgetId, mRequest.getAppWidgetProviderInfo(this), mWidgetOptions)
//        if (success) {
//            acceptWidget(mPendingBindWidgetId)
//            return
//        }
//
//        // request bind widget
//        val intent = Intent(AppWidgetManager.ACTION_APPWIDGET_BIND)
//        intent.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, mPendingBindWidgetId)
//        intent.putExtra(AppWidgetManager.EXTRA_APPWIDGET_PROVIDER,
//                mPendingWidgetInfo.componentName)
//        intent.putExtra(AppWidgetManager.EXTRA_APPWIDGET_PROVIDER_PROFILE,
//                mRequest.getAppWidgetProviderInfo(this).getProfile())
//        startActivityForResult(intent, REQUEST_BIND_APPWIDGET)
    }
}