package com.teslacoilsw.launcher.notificationlistener

import com.android.launcher3.notification.NotificationKeyData
import com.teslacoilsw.notifier.widget.BadgeArt
import com.teslacoilsw.notifier.widget.EmptyBadgeArt
import java.util.*

data class BadgeData(val key: ComponentKeyMatcher, val badgeArt: BadgeArt, val lastPostedTime: Long, val notificationKeys: List<NotificationKeyData>) {

    fun getNotificationCount(): Int = Math.max(MAX_COUNT, notificationKeys.sumBy { it.count })

    companion object {
        private const val MAX_COUNT = 999
        private val EMPTY_BADGE_DATA = BadgeData(ComponentKeyMatcher.EMPTY_MATCHER, EmptyBadgeArt.get(), java.lang.Long.MIN_VALUE, Collections.emptyList())
        fun emptyBadgeData(matcher: ComponentKeyMatcher?): BadgeData =
            if (matcher != null)
                BadgeData(matcher, EmptyBadgeArt.get(), Long.MIN_VALUE, Collections.emptyList())
            else
                EMPTY_BADGE_DATA
    }
}