package com.teslacoilsw.launcher.notificationlistener

import android.content.Context
import android.service.notification.StatusBarNotification
import com.android.launcher3.ItemInfo
import com.android.launcher3.compat.UserHandleCompat
import com.android.launcher3.compat.UserManagerCompat
import com.android.launcher3.util.ComponentKey

data class PackageUser(val pkg: String, val user: UserHandleCompat) {
    fun flattenToString(context: Context): String =
            "$pkg#${UserManagerCompat.getInstance(context).getSerialNumberForUser(user)}"

    companion object {
        @JvmStatic fun fromItemInfo(info: ItemInfo): PackageUser {
            return PackageUser(info.targetComponent!!.packageName, info.user)
        }

        @JvmStatic fun fromNotification(notification: StatusBarNotification): PackageUser {
            return PackageUser(notification.packageName, UserHandleCompat.fromUser(notification.user)!!)
        }
    }

    fun matches(componentKey: ComponentKey): Boolean {
        return componentKey.componentName.packageName == pkg && componentKey.user == user;
    }
}
