package com.teslacoilsw.launcher.novawidget

import android.appwidget.AppWidgetProviderInfo
import android.content.ComponentName
import android.content.Context
import com.android.launcher3.model.CustomAppWidget
import com.teslacoilsw.launcher.BuildConfig
import com.teslacoilsw.launcher.R

val quickSearchBarWidget = BaseCustomWidgetInfo("quicksearchbar", R.string.preference_search_bar, R.drawable.qsb_preview_novawidget, R.drawable.launcher_shortcut_search, R.layout.novawidget_qsb, AppWidgetProviderInfo.RESIZE_HORIZONTAL, 4f, 1f, 1f, 1f)
val customAppWidgets: List<CustomAppWidget> = listOf(
    quickSearchBarWidget
)

fun getCustomAppWidget(provider: ComponentName): CustomAppWidget? {
    for (i in 0 until customAppWidgets.size) {
        val x = customAppWidgets[i]
        if (x.identifier == provider) {
            return x
        }
    }
    return null
}

class BaseCustomWidgetInfo : CustomAppWidget {

    private val shortIdentifier: String
    private val labelResId: Int
    private val previewImageId: Int
    private val iconId: Int
    private val widgetLayoutId: Int
    private val _resizeMode: Int
    private val _spanX: Float
    private val _spanY: Float
    private val _minSpanX: Float
    private val _minSpanY: Float

    internal constructor(identifier: String, labelResId: Int, previewImageId: Int, iconId: Int, widgetLayoutId: Int, resizeMode: Int, spanX: Float, spanY: Float, minSpanX: Float, minSpanY: Float) {
        this.shortIdentifier = identifier
        this.labelResId = labelResId
        this.previewImageId = previewImageId
        this.iconId = iconId
        this.widgetLayoutId = widgetLayoutId
        this._resizeMode = resizeMode
        this._spanX = spanX
        this._spanY = spanY
        this._minSpanX = spanX
        this._minSpanY = spanY

    }

    override fun getLabel(context: Context): String {
        return context.getString(labelResId)
    }

    override fun getPreviewImage() = previewImageId

    override fun getIcon() = iconId

    override fun getWidgetLayout() = widgetLayoutId

    override fun getSpanX() = _spanX

    override fun getSpanY() = _spanY

    override fun getMinSpanX() = _minSpanX

    override fun getMinSpanY() = _minSpanY

    override fun getResizeMode() = _resizeMode

    override fun getIdentifier() = ComponentName(BuildConfig.APPLICATION_ID, BuildConfig.APPLICATION_ID + ".novawidget." + shortIdentifier)
}