package com.teslacoilsw.launcher.widget

import android.graphics.Canvas
import android.graphics.Paint
import android.graphics.PorterDuff
import android.graphics.PorterDuffXfermode
import com.teslacoilsw.kotlin.resetAfter

class FadingEdgeScrimHelper {
    private val paint by lazy(LazyThreadSafetyMode.NONE) { Paint().apply {
            color = 0x80FFFFFF.toInt(); xfermode = PorterDuffXfermode(PorterDuff.Mode.DST_OUT) }
    }


    private var topScrimHeight = 0
    private var bottomScrimHeight = 0

    fun setScrimHeight(top: Int, bottom: Int) {
        topScrimHeight = top
        bottomScrimHeight = bottom
    }

    fun dispatchDraw(canvas: Canvas, left: Int, top: Int, right: Int, bottom: Int, body: () -> Unit) {
        canvas.resetAfter {
            if (topScrimHeight > 0)
                canvas.saveLayer(left.toFloat(), top.toFloat(), right.toFloat(), (top + topScrimHeight).toFloat(), null, Canvas.HAS_ALPHA_LAYER_SAVE_FLAG)
            if (bottomScrimHeight > 0)
                canvas.saveLayer(left.toFloat(), (bottom - bottomScrimHeight).toFloat(), right.toFloat(), bottom.toFloat(), null, Canvas.HAS_ALPHA_LAYER_SAVE_FLAG)

            body()

            if (topScrimHeight > 0)
                canvas.drawRect(left.toFloat(), top.toFloat(), right.toFloat(), (top + topScrimHeight).toFloat(), paint)

            if (bottomScrimHeight > 0)
                canvas.drawRect(left.toFloat(), (bottom - bottomScrimHeight).toFloat(), right.toFloat(), bottom.toFloat(), paint)
        }
    }

}