package com.teslacoilsw.launcher.widget

import android.view.View
import android.view.ViewGroup

class Rotate90FrameLayout(private val child: View) : ViewGroup(child.context) {

    init {
        addView(child)
        child.rotation = -90f
        clipChildren = false
    }

    override fun onLayout(changed: Boolean, l: Int, t: Int, r: Int, b: Int) {
        val cx = width/2
        val cy = height/2
        val childWidth = child.measuredWidth
        val childHeight = child.measuredHeight

        val widthA = childWidth/2
        val widthB = childWidth - widthA
        val heightA = childHeight/2
        val heightB = childHeight - heightA
        child.layout(cx - widthA, cy - heightA, cx + widthB, cy + heightB)
    }

    override fun onMeasure(widthMeasureSpec: Int, heightMeasureSpec: Int) {
        child.measure(MeasureSpec.makeMeasureSpec(MeasureSpec.getSize(heightMeasureSpec), MeasureSpec.EXACTLY), MeasureSpec.makeMeasureSpec(View.MeasureSpec.getSize(widthMeasureSpec), MeasureSpec.EXACTLY))
        setMeasuredDimension(MeasureSpec.getSize(widthMeasureSpec), View.MeasureSpec.getSize(heightMeasureSpec))
    }
}